
public class Point {

   public int x;
   public int y;
   
   public Point(int x, int y) {
      this.x = x;
      this.y = y;
   }
   
   public final int distance(Point p) {
      //since we can't move diagonally, this is the minimum distance 
      //i.e. number of turns it could take to get from here to p
      return Math.abs(p.x - x) + Math.abs(p.y - y);
   }
   
   public final boolean equals(Object p) {
      return (p != null) && (p instanceof Point) && (x == ((Point)p).x) && (y == ((Point)p).y);
   }
   
   public String toString() {
      return "(" + x + ", " + y + ")";
   }
   
   public final int hashCode() {
      return (x + "," + y).hashCode();
   }

}